-- die.e
--
-- Ben Lin 6/98
--
-- The die command can be executed on any blackboard.
-- (it kills on execute, and undoes the kill on unexecute)

class DIE inherit COMMAND redefine display
	-- This command kills the blackboard. Use when the solution is invalid
creation make
feature

	make(blackboard : BLACKBOARD) is
		-- Make a die command that will kill `blackboard'.
	do
		bb := blackboard
	end

	plain_execute is
		-- tell the blackboard to die
	do
		bb.suicide
	end

	plain_unexecute is
		-- resurrect the blackboard
	do
		bb.rebirth
	end

	append_forced is
		-- does nothing: if dead, there's no point calling any observers
	do
	end

	can_execute : BOOLEAN is
		-- true if the blackboard can die, i.e. it's alive
	do
		Result := bb.alive
	end

	finished : BOOLEAN is
		-- true if the blackboard has already died
	do
		Result := not bb.alive
	end

	display is
		-- show information about this command
	do
		io.put_string("Die%N")
	end
end
