class IDFS_SEARCH inherit SEARCH_STRATEGY
	-- interactive depth-first search - shows blackboard at every state,
	-- (uses ANSI sequences) and asks user whether the search should be
	-- continued once a solution is found

feature

	display_list(list : COLLECTION[COMMAND]) is
	local
		i : integer
	do
		io.put_string("Suggestions:%N")
		from i := list.lower
		until i > list.upper
		loop
			list.item(i).display
			i := i + 1
		end
	end

	doit(bb : BLACKBOARD) is
	local
		i : INTEGER
		command_list : COMMAND_LIST
	do
		command_list := bb.get_open
		from i := command_list.lower
		until bb.finished or i > command_list.upper
		loop
			command_list.item(i).execute
			io.put_string("%/27/[1;1H")
			bb.display
			doit(bb)
			if not bb.finished
			then
				command_list.item(i).unexecute
				i := i + 1
			else
				io.put_string("continue?")
				io.read_character
				if io.last_character = 'y' then
					io.read_character
					io.put_string("continuing...%N")
					command_list.item(i).unexecute
					i := i + 1
				end

			end
		end

	end

	display is
	do
		io.put_string("Interactive Depth First Search%N")
	end
end

