-- Logic problem - "Panic in Poshville"
-- from "Logic Problems" No. 15 (by A.J. Duncum)
-- Ben Lin 26/5/98
--
-- See limber.e for another example

class PANIC
creation make
feature
	pb : LP_BOARD
	size : INTEGER is 5
	sub_count : INTEGER is 4

	-- The 4 categories are:
	-- 1 = Hostess (1 = Mrs Butterwell, 2 = Mrs Kleimer, 3 = Mrs Pushey.
	--		4 = Mrs Snobbs, 5 = Mrs Woodby-Sumbody)
	-- 2 = Guest (1 = Bishop, 2 = Police Sergeant, 3 = Headmaster,
	--		4 = Husband's boss, 5 = Local MP)
	-- 3 = Domestic crisis (1 = Burnt steaks, 2 = Cook walked out,
	-- 		3 = Dropped soup tureen, 4 = Forgot to switch on oven,
	--		5 = Wine not delivered)
	-- 4 = Social problem (1 = Argumentative guest, 2 = Awful relatives
	--		dropped in, 3 = Hostess got tipsy, 4 = Husband told risque jokes,
	--		5 = Malicious gossip)

	--ss : DFS_SEARCH
	ss : I_SEARCH

	make is
	do
		!!pb.make(sub_count, size)
		setup_clues
		!!ss
		ss.doit(pb)
		if not pb.finished then
			io.put_string("No solution! :(%N")
		else
			io.put_string("Solution found:%N")
			pb.display
		end
	end

	setup_clues is
	do
		tick(2, 4, 1, 4)
			-- 1. bishop embarassed by risque jokes

		tick(1, 4, 5, 2)
			-- 2. Mrs Woodby-Sumbody - awful relatives

		cross(1, 3, 5, 2)
			-- 2. ...she does her own cooking, so there was no cook

		tick(3, 4, 4, 1)
			-- 3. forgot to switch on oven, and later there was an argument

		tick(1, 3, 4, 5)
			-- 4. Mrs Snobbs - wine not delivered

		cross(1, 4, 4, 5)
			-- 4. ...gossip not at her dinner

		cross(1, 4, 4, 3)
			-- 4. ...drank water, so couldn't have been drunk

		tick(1, 2, 2, 2)
			-- 5. Mrs Kleimer's guest was the police sergeant

		cross(1, 3, 2, 2)
			-- 5. ...not where the cook walked out

		cross(1, 4, 2, 3)
			-- 5. ...not where the hostess got tipsy

		cross(3, 4, 2, 3)
			-- 5. ...cook walked out of a different dinner to the one where
			-- the hostess got tipsy

		tick(2, 3, 4, 3)
			-- 6. dropped tureen while serving husband's boss

		cross(2, 3, 3, 1)
			-- 7. headmaster not guest at the dinner with burnt steaks

		cross(1, 2, 1, 3)
			-- 7. ...headmaster not Mrs Butterwell's guest

		cross(1, 3, 1, 1)
			-- 7. ...and steaks weren't burnt at Mrs Butterwell's dinner
	end

	tick(i, j, x, y : INTEGER) is
	local
		at : ADD_TICK
	do
		!!at.make(pb, i, j, x, y)
		do_initial_command(at)
	end

	cross(i, j, x, y : INTEGER) is
	local
		ac : ADD_CROSS
	do
		!!ac.make(pb, i, j, x, y)
		do_initial_command(ac)
	end

	do_initial_command(c : COMMAND) is
	do
		if c.finished then
			io.put_string("warning: ")
			c.display
			io.put_string("already executed%N")
		elseif not c.can_execute then
			io.put_string("warning: ")
			c.display
			io.put_string(" => no solution%N")
		end
		c.execute
	end
	
end
