-- Ben Lin 5/98
class PROPAGATE_CROSS inherit OBSERVER
	-- Propagates crosses
	-- For example: If X is Y, and a cross is placed meaning X is not Z,
	-- then this will generate a cross meaning Y is not Z, or a die
	-- command if this is not possible.

creation make
feature
	make is
	do
	end

	update(last : ADD_CROSS) is
	local
		crossi, crossj : INTEGER
		crossrow, crosscol : INTEGER
		i : INTEGER
		x : INTEGER
		bb : LP_BOARD
	do
		bb := last.bb
		crossi := last.i
		crossj := last.j
		crossrow := last.x
		crosscol := last.y

		from
			i := 1
		until i > bb.sub_count
		loop
			if i /= crossi and i /= crossj then
				from
					x := 1
				until x > bb.size
				loop

					propagate(last, crossi, i, crossj, crossrow, x, crosscol)
					x := x + 1
				end
			end
			i := i + 1
		end
	end
	
	propagate(last : ADD_CROSS; i, j, k, x, y, z : INTEGER) is
	require
		i /= j
		j /= k
	local
		bb : LP_BOARD
	do
		bb := last.bb

		inspect bb.board.item(i, j, x, y)
		when 1 then
			inspect bb.board.item(j, k, y, z)
			when 0 then
				last.forced_cross(j, k, y, z)
			when 1 then
				last.forced_die
			else
			end
		when 0 then
			inspect bb.board.item(j, k, y, z)
			when 1 then
				last.forced_cross(i, j, x, y)
			else
			end
		else
		end
	end
end
