-- "Tick Grid"
-- Ben Lin
-- 27/5/98
--
-- Like a logic grid of integers, but only need to write `item' once
-- (so item(i, j, x, y) = item(j, i, y, x))
--

class TICK_GRID
creation make
feature
	make(count, size : INTEGER) is
	do
		!!storage.make(count, size)
	end

	tick(i, j, x, y : INTEGER) is
	do
		storage.put(1, i, j, x, y)
	end

	cross(i, j, x, y : INTEGER) is
	do
		storage.put(-1, i, j, x, y)
	end

	blank(i, j, x, y : INTEGER) is
	do
		storage.put(0, i, j, x, y)
	end

	put(n, i, j, x, y : INTEGER) is
	do
		storage.put(n, i, j, x, y)
	end

	is_tick(i, j, x, y : INTEGER) : BOOLEAN is
	do
		Result := storage.item(i, j, x, y) = 1
	end

	is_cross(i, j, x, y : INTEGER) : BOOLEAN is
	do
		Result := storage.item(i, j, x, y) = -1
	end

	is_blank(i, j, x, y : INTEGER) : BOOLEAN is
	do
		Result := storage.item(i, j, x, y) = 0
	end

	is_equal(n, i, j, x, y : INTEGER) : BOOLEAN is
	do
		Result := storage.item(i, j, x, y) = n
	end

	item(i, j, x, y : INTEGER) : INTEGER is
	do
		Result := storage.item(i, j, x, y) 
	end

feature {NONE}
	storage : LOGIC_GRID[INTEGER]

end

